from networks access *;

picture P1, P2, P3;

network N1;
tensor P = N1.add_tensor((40, 0), 10, 10, label="$P$");
tensor Q = N1.add_tensor((80, 0), 10, 10, label="$Q$");
tensor x = N1.add_tensor((120, 0), 10, 10, label="$x$");
N1.join((10, 0), P.mid-(10,0), label="$i$");
N1.join(P.mid, Q.mid, label="$k$");
N1.join(Q.mid, x.mid, label="$j$");
N1.draw(P1);
draw(P1, (65,-15)--(135,-15)--(135,15)--(65,15)--cycle, p=blue+dashed);
label(P1, "[contract]", position=(100, -25), p=blue);

network N2;
tensor P = N2.add_tensor((40, 0), 10, 10, label="$P$");
tensor Qx = N2.add_tensor((80, 0), 10, 10, label="$Qx$");
N2.join((10, 0), P.mid-(10,0), label="$i$");
N2.join(P.mid, Qx.mid, label="$k$");
N2.draw(P2);
draw(P2, (25,-15)--(95,-15)--(95,15)--(25,15)--cycle, p=blue+dashed);
label(P2, "[contract]", position=(60, -25), p=blue);

network N3;
tensor PQx = N3.add_tensor((40, 0), 15, 10, label="$PQx$");
N3.join((10, 0), PQx.mid-(15,0), label="$i$");
N3.draw(P3);


add(P1, (0, 0));
add(P2, (240, 0));
add(P3, (440, 0));

draw((150,-2)--(230,-2), p=blue);
draw((150,2)--(230,2), p=blue);
draw((224,-6)--(233,0)--(224,6), p=blue);
label("$O(nr)$ operations", position=(190,-25), p=blue);

draw((350,-2)--(430,-2), p=blue);
draw((350,2)--(430,2), p=blue);
draw((424,-6)--(433,0)--(424,6), p=blue);
label("$O(nr)$ operations", position=(390,-25), p=blue);

