from net_3tensor access *;

picture P1, P2, P3;

void draw_tensor(picture P, string name, int T[][][]) {
  int x_gap=11;
  label(P, "$" + name + " =$", (-20, (7-42)/2));
  for (int i = 0; i < 2; ++i) {
    draw(P, (-3, -25*i+5)--(-5, -25*i+5)--(-5, -25*i-15)--(-3, -25*i-15));
    draw(P, (6*x_gap+3, -25*i+5)--(6*x_gap+5, -25*i+5)--(6*x_gap+5, -25*i-15)--(6*x_gap+3, -25*i-15));
    label(P, "1", (6*x_gap+8, -25*i-5), magenta+fontsize(7pt));
    for (int j = 0; j < 2; ++j)
      for (int k = 0; k < 7; ++k) {
        label(P, string(T[i][j][k]), (k*x_gap, -(25*i + 10*j)));
      }
  }
  draw(P, (-6, 7)--(-8, 7)--(-8, -42)--(-6,-42));
  draw(P, (6*x_gap+10, 7)--(6*x_gap+12, 7)--(6*x_gap+12, -42)--(6*x_gap+10,-42));
  label(P, "0", (6*x_gap+15, (7-42)/2), magenta+fontsize(7pt));
  label(P, "2", (3*x_gap, -45), magenta+fontsize(7pt));
}

int alpha[][][] = {{{1, 0, 1, 0, 1, -1, 0},
                    {0, 0, 0, 0, 1, 0, 1}},
                   {{0, 1, 0, 0, 0, 1, 0},
                    {1, 1, 0, 1, 0, 0, -1}}};
int beta[][][] = {{{1, 1, 0, -1, 0, 1, 0},
                   {0, 0, 1, 0, 0, 1, 0}},
                  {{0, 0, 0, 1, 0, 0, 1},
                   {1, 0, -1, 0, 1, 0, 1}}};
int gamma[][][] = {{{1, 0, 0, 1, -1, 0, 1},
                    {0, 0, 1, 0, 1, 0, 0}},
                   {{0, 1, 0, 1, 0, 0, 0},
                    {1, -1, 1, 0, 0, 1, 0}}};

draw_tensor(P1, "\alpha", alpha);
draw_tensor(P2, "\beta", beta);
draw_tensor(P3, "\gamma", gamma);
add(P1);
add(P2, (125, 0));
add(P3, (250, 0));
